package roneditor.dialogs;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.cloudgarden.resource.SWTResourceManager;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class CreateHLPlaceOrTokenDialog extends org.eclipse.swt.widgets.Dialog {

	private Shell dialogShell;

	private Button ruleRadioButton;

	private Button cancelButton;

	private Button oKbutton;

	private Text nameText;

	private Label nameLabel;

	private Button netRadioButton;

	private boolean cancelled;

	private String nameTextValue;

	private boolean isNetType;

	/**
	 * Auto-generated main method to display this org.eclipse.swt.widgets.Dialog
	 * inside a new Shell.
	 */
	public static void main(final String[] args) {
		try {
			final Display display = Display.getDefault();
			final Shell shell = new Shell(display);
			final CreateHLPlaceOrTokenDialog inst = new CreateHLPlaceOrTokenDialog(
					shell, SWT.NULL);
			inst.open();
		} catch (final Exception e) {
			e.printStackTrace();
		}
	}

	public CreateHLPlaceOrTokenDialog(final Shell parent, final int style) {
		super(parent, style);
	}

	public void open() {
		try {
			final Shell parent = getParent();
			dialogShell = new Shell(parent, SWT.DIALOG_TRIM
					| SWT.APPLICATION_MODAL);
			final GridLayout dialogShellLayout = new GridLayout();
			dialogShellLayout.makeColumnsEqualWidth = true;
			dialogShellLayout.numColumns = 2;
			dialogShell.setBounds(450, 265, 160, 119);

			{
				// Register as a resource user - SWTResourceManager will
				// handle the obtaining and disposing of resources
				SWTResourceManager.registerResourceUser(dialogShell);
			}

			dialogShell.setLayout(dialogShellLayout);
			dialogShell.addKeyListener(new KeyAdapter() {
				@Override
				public void keyReleased(final KeyEvent evt) {
					enterOrESCKeyReleased(evt);
				}
			});
			// START >> netRadioButton
			netRadioButton = new Button(dialogShell, SWT.RADIO | SWT.LEFT);
			netRadioButton.setText("NET");
			netRadioButton.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(final MouseEvent evt) {
					netRadioButtonMouseUp(evt);
				}
			});
			// END << netRadioButton
			// START >> ruleRadioButton
			ruleRadioButton = new Button(dialogShell, SWT.RADIO | SWT.LEFT);
			ruleRadioButton.setText("RULE");
			ruleRadioButton.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(final MouseEvent evt) {
					ruleRadioButtonMouseUp(evt);
				}
			});
			// END << ruleRadioButton
			// START >> nameLabel
			nameLabel = new Label(dialogShell, SWT.NONE);
			nameLabel.setText("Name:");
			// END << nameLabel
			// START >> nameText
			nameText = new Text(dialogShell, SWT.NONE);
			nameText.addKeyListener(new KeyAdapter() {
				@Override
				public void keyReleased(final KeyEvent evt) {
					enterOrESCKeyReleased(evt);
				}
			});
			// END << nameText
			// START >> oKbutton
			oKbutton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			oKbutton.setText("OK");
			oKbutton.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(final MouseEvent evt) {
					oKbuttonMouseUp(evt);
				}
			});
			// END << oKbutton
			// START >> cancelButton
			cancelButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			cancelButton.setText("Cancel");
			cancelButton.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(final MouseEvent evt) {
					cancelButtonMouseUp(evt);
				}
			});
			// END << cancelButton

			init();

			dialogShell.layout();
			dialogShell.pack();
			dialogShell.open();
			final Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) {
				if (!display.readAndDispatch()) {
					display.sleep();
				}
			}
		} catch (final Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * To be implemented by subclasses to initialize the Place or Token mode!
	 */
	protected void init() {

	}

	protected Shell getDialogShell() {
		return dialogShell;
	}

	protected Button getRuleRadioButton() {
		return ruleRadioButton;
	}

	protected Button getNetRadioButton() {
		return netRadioButton;
	}

	protected Text getNameText() {
		return nameText;
	}

	private void oKbuttonMouseUp(@SuppressWarnings("unused")
	final MouseEvent evt) {
		// store data that can be rretrived after widgets have been disposed
		cancelled = false;
		nameTextValue = nameText.getText();
		isNetType = netRadioButton.getSelection();
		dialogShell.close();
	}

	public String getNameTextValue() {
		return nameTextValue;
	}

	public boolean isNetType() {
		return isNetType;
	}

	private void cancelButtonMouseUp(@SuppressWarnings("unused")
	final MouseEvent evt) {
		cancelled = true;
		dialogShell.close();
	}

	private void enterOrESCKeyReleased(final KeyEvent evt) {
		if (evt.keyCode == 13) {
			oKbuttonMouseUp(null);
		}
		if (evt.keyCode == SWT.ESC) {
			cancelButtonMouseUp(null);
		}
	}

	public boolean isCancelled() {
		return cancelled;
	}

	private void netRadioButtonMouseUp(@SuppressWarnings("unused")
	final MouseEvent evt) {
		if (netRadioButton.isEnabled()) {
			netRadioButton.setSelection(true);
			ruleRadioButton.setSelection(false);
		}
	}

	private void ruleRadioButtonMouseUp(@SuppressWarnings("unused")
	final MouseEvent evt) {
		if (ruleRadioButton.isEnabled()) {
			ruleRadioButton.setSelection(true);
			netRadioButton.setSelection(false);
		}
	}
}
