package roneditor.model;

import org.eclipse.core.runtime.Assert;
import org.eclipse.gef.requests.CreationFactory;

/**
 * This class implements the CreationFactory used by the CreationTool. It uses
 * the EMF-generated factories to create the model instances.
 * 
 * @author Tony Modica
 */
public class ModelCreationFactory implements CreationFactory {

	final private Class<?> targetClass;

	public ModelCreationFactory(final Class<?> targetClass) {
		this.targetClass = targetClass;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.requests.CreationFactory#getNewObject()
	 */
	public Object getNewObject() {
		final Object result = null;
		// if (this.targetClass.equals(Place.class)) {
		// result = fac.createPlace();
		// }
		Assert.isNotNull(result,
				"ModelCreationFactory could not create a model!");
		return result;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.requests.CreationFactory#getObjectType()
	 */
	public Object getObjectType() {
		return targetClass;
	}
}
