package roneditor.objectnetview;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.tools.ConnectionCreationTool;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Shell;

import roneditor.RONActivator;
import roneditor.objectnetview.commands.CreateONArcCommand;
import roneditor.objectnetview.dialogs.ONArcPropertiesDialog;
/**
 * ConnectionCreationTool for ObjectNets
 */
public class ObjectNetConnectionCreationTool extends ConnectionCreationTool {

	public ObjectNetConnectionCreationTool() {
		super();
	}

	public ObjectNetConnectionCreationTool(CreationFactory factory) {
		super(factory);
	}

	/**
	 * Bei {@link CreateONArcCommand} ffnet sich ein {@link #openLinkRoleDialog(Command) DialogFenster} 
	 * fr Benutzer Eingabe
	 * @see org.eclipse.gef.tools.AbstractTool#executeCurrentCommand()
	 */
	protected void executeCurrentCommand() {
		Command command = getCurrentCommand();
		if ((command instanceof CreateONArcCommand) && command.canExecute()) {
			if (!openLinkRoleDialog(command))
				return;
		}
		super.executeCurrentCommand();
	}

	/**
	 * 
	 * @param command CreateONArcCommand
	 * @return true wenn Alle Eingaben richtig sind, false bei Cancel oder
	 * eine Eingabe Falsch ist 
	 */
	private boolean openLinkRoleDialog(Command command) {
		if (command instanceof CreateONArcCommand) {
			CreateONArcCommand connectionONNodeCommand = (CreateONArcCommand) command;
			Shell shell = RONActivator.getDefault().getWorkbench()
					.getActiveWorkbenchWindow().getShell();
			ONArcPropertiesDialog d = new ONArcPropertiesDialog(shell, SWT.NULL);
			d.setTitle("create ONArc");
			d.setWeight(1);
			d.open();
			if (d.isCancelled() || d.getWeight() <= 0) {
				return false;
			}
			connectionONNodeCommand.setWeight(d.getWeight());
		}
		return true;
	}
}