package roneditor.objectnetview.commands;

import ronmodel.LHS;
import ronmodel.ONPlace;
import ronmodel.ObjectNet;

/**
 * Command for creating a place.
 */
public class CreateONPlaceCommand extends org.eclipse.gef.commands.Command {
	private ONPlace onPlace;

	private int x;

	private int y;

	private ObjectNet objectNet;

	private String name;

	private int tokens;

	private int mappingID;

	/**
	 * Constructor.
	 * 
	 */
	public CreateONPlaceCommand() {
		setLabel("create Place");
	}

	/**
	 * Entry point for command execution.
	 * Ein {@link ONPlace} wird in einem {@link ObjectNet} eingefgt
	 */
	public void execute() {
		onPlace.setObjectNet(objectNet);
		onPlace.setName(name);
		onPlace.setTokens(tokens);
		onPlace.setX(x);
		onPlace.setY(y);
		if (objectNet instanceof LHS) {
			mappingID = ((LHS) objectNet).getCurrentMappingID() + 1;
			((LHS) objectNet).setCurrentMappingID(mappingID);
			onPlace.setMappingID(mappingID);
		}
	}

	/**
	 * Redo command execution.
	 */
	public void redo() {
		onPlace.setObjectNet(objectNet);
	}

	/**
	 * Undo command execution.
	 */
	public void undo() {
		onPlace.setObjectNet(null);
	}

	/**
	 * @return the client
	 */
	public ONPlace getONPlace() {
		return onPlace;
	}

	/**
	 * @param onPlace
	 *            the client to set
	 */
	public void setONPlace(ONPlace onPlace) {
		this.onPlace = onPlace;
	}

	/**
	 * @return the network
	 */
	public ObjectNet getObjectNet() {
		return objectNet;
	}

	/**
	 * @param objectNet
	 *            the network to set
	 */
	public void setObjectNet(ObjectNet objectNet) {
		this.objectNet = objectNet;
	}

	/**
	 * @return the x
	 */
	public int getX() {
		return x;
	}

	/**
	 * @param x
	 *            the x to set
	 */
	public void setX(int x) {
		this.x = x;
	}

	/**
	 * @return the y
	 */
	public int getY() {
		return y;
	}

	/**
	 * @param y
	 *            the y to set
	 */
	public void setY(int y) {
		this.y = y;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name
	 *            the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	public int getTokens() {
		return tokens;
	}

	public void setTokens(int tokens) {
		this.tokens = tokens;
	}
}
