package roneditor.objectnetview.commands;

import ronmodel.LHS;
import ronmodel.ONTransition;
import ronmodel.ObjectNet;

/**
 * Command for creating a Transition.
 */
public class CreateONTransitionCommand extends org.eclipse.gef.commands.Command {
	private ONTransition onTransition;

	private int x;

	private int y;

	private ObjectNet objectNet;

	private String name;

	private int mappingID;

	/**
	 * Constructor.
	 * 
	 */
	public CreateONTransitionCommand() {
		setLabel("create transition");
	}

	/**
	 * Entry point for command execution.
	 * ein {@link ONTransition} wird in einem {@link ObjectNet} eingefgt
	 */
	public void execute() {
		onTransition.setObjectNet(objectNet);
		onTransition.setName(name);
		onTransition.setX(x);
		onTransition.setY(y);
		if (objectNet instanceof LHS) {
			mappingID = ((LHS) objectNet).getCurrentMappingID() + 1;
			((LHS) objectNet).setCurrentMappingID(mappingID);
			onTransition.setMappingID(mappingID);
		}
	}

	/**
	 * Redo command execution.
	 */
	public void redo() {
		onTransition.setObjectNet(objectNet);
	}

	/**
	 * Undo command execution.
	 */
	public void undo() {
		onTransition.setObjectNet(null);
	}

	/**
	 * @return the server
	 */
	public ONTransition getServer() {
		return onTransition;
	}

	/**
	 * @param onTransition
	 *            the server to set
	 */
	public void setServer(ONTransition onTransition) {
		this.onTransition = onTransition;
	}

	/**
	 * @return the network
	 */
	public ObjectNet getObjectNet() {
		return objectNet;
	}

	/**
	 * @param objectNet
	 *            the network to set
	 */
	public void setObjectNet(ObjectNet objectNet) {
		this.objectNet = objectNet;
	}

	/**
	 * @return the x
	 */
	public int getX() {
		return x;
	}

	/**
	 * @param x
	 *            the x to set
	 */
	public void setX(int x) {
		this.x = x;
	}

	/**
	 * @return the y
	 */
	public int getY() {
		return y;
	}

	/**
	 * @param y
	 *            the y to set
	 */
	public void setY(int y) {
		this.y = y;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name
	 *            the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}
}
