package roneditor.objectnetview.commands;

import ronmodel.BendPoint;
import ronmodel.ONArc;

/**
 * @author Waldemar
 */
/**
 * DeleteBendpointCommand deletes a Bendpoint.
 */
public class DeleteBendpointCommand extends AbstractBendpointCommand {

	/**
	 * ein {@link BendPoint} von einem {@link ONArc} wird gelscht 
	 */
	public void execute() {
		bendPoint = (BendPoint) getONArc().getBendPoints().get(getIndex());
		getONArc().getBendPoints().remove(bendPoint);
	}
	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		getONArc().getBendPoints().add(getIndex(), bendPoint);
	}

}
