package roneditor.objectnetview.commands;

import org.eclipse.gef.commands.Command;

import ronmodel.ONNode;

/**
 * Edit node properties.
 */
public abstract class EditONNodeCommand extends Command {
	private ONNode onNode;

	private String oldName = "";

	private String newName = "";

	/**
	 * Properties von einem {@link ONNode} ndern 
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		oldName = onNode.getName();
		onNode.setName(newName);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		onNode.setName(oldName);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		onNode.setName(newName);
	}

	/**
	 * @return the node
	 */
	public ONNode getONNode() {
		return onNode;
	}

	/**
	 * @param onNode
	 *            the node to set
	 */
	public void setONNode(ONNode onNode) {
		this.onNode = onNode;
	}

	/**
	 * @return the newName
	 */
	public String getNewName() {
		return newName;
	}

	/**
	 * @param newName
	 *            the newName to set
	 */
	public void setNewName(String newName) {
		this.newName = newName;
	}

}
