package roneditor.objectnetview.edit.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import roneditor.objectnetview.commands.DeleteONNodeCommand;
import ronmodel.ONNode;
import ronmodel.ObjectNet;

/**
 * EditPolicy for {@link ONNode} component.
 */
public class ONNodeComponentEditPolicy extends ComponentEditPolicy {


	public ONNodeComponentEditPolicy() {
		super();
	}

	/**
	 * @see org.eclipse.gef.editpolicies.ComponentEditPolicy#createDeleteCommand(org.eclipse.gef.requests.GroupRequest)
	 */
	protected Command createDeleteCommand(GroupRequest deleteRequest) {
		ObjectNet objectNet = (ObjectNet) getHost().getParent().getModel();
		ONNode onNode = (ONNode) getHost().getModel();
		DeleteONNodeCommand deleteCmd = new DeleteONNodeCommand();
		deleteCmd.setObjectNet(objectNet);
		deleteCmd.setONNode(onNode);
		return deleteCmd;
	}
}
