package roneditor.objectnetview.edit.utils;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;

import roneditor.objectnetview.edit.parts.ONArcEditPart;
import roneditor.objectnetview.edit.parts.ONPlaceEditPart;
import roneditor.objectnetview.edit.parts.ONTransitionEditPart;
import roneditor.objectnetview.edit.parts.ObjectNetEditPart;
import ronmodel.ONArc;
import ronmodel.ONPlace;
import ronmodel.ONTransition;
import ronmodel.ObjectNet;

/**
 * Factory class for graphical edit parts. Here, the corresponding edit parts of
 * a {@link ObjectNet} are created.
 */
public class ObjectNetViewEditPartFactory implements EditPartFactory {

	public ObjectNetViewEditPartFactory() {
		super();
	}

	/**
	 * @see org.eclipse.gef.EditPartFactory#createEditPart(org.eclipse.gef.EditPart,
	 *      java.lang.Object)
	 */
	public EditPart createEditPart(EditPart context, Object obj) {
		if (obj instanceof ObjectNet) {
			ObjectNetEditPart p = new ObjectNetEditPart((ObjectNet) obj);
			return p;
		} else if (obj instanceof ONPlace) {
			ONPlaceEditPart p = new ONPlaceEditPart((ONPlace) obj);
			return p;
		} else if (obj instanceof ONTransition) {
			ONTransitionEditPart p = new ONTransitionEditPart(
					(ONTransition) obj);
			return p;
		} else if (obj instanceof ONArc)
			return new ONArcEditPart((ONArc) obj);
		return null;
	}
}
