package roneditor.ronview.commands;

import roneditor.model.RONModelManager;
import roneditor.objectnetview.commands.AbstractBendpointCommand;
import ronmodel.BendPoint;
import ronmodel.HLArc;
import ronmodel.RonmodelFactory;
/**
 * class for creation a new {@link BendPoint}
 */
public class CreateHLBendpointCommand extends AbstractBendpointCommand {
	/**
	 * ein Bendpoint wird fr ein {@link HLArc} eingefgt
	 */
	public void execute() {
		RonmodelFactory mfc = RONModelManager.getFactory();
		bendPoint = mfc.createBendPoint();
		// Speichern der relativen Position zum 1. Object
		bendPoint.getH().add(new Integer(getFirstRelativeDimension().height));
		bendPoint.getW().add(new Integer(getFirstRelativeDimension().width));

		// Speichern der relativen Position zum 2. Object
		bendPoint.getH().add(new Integer(getSecondRelativeDimension().height));
		bendPoint.getW().add(new Integer(getSecondRelativeDimension().width));

		// BendPoint hinzufgen
		getHLArc().getBendPoints().add(getIndex(), bendPoint);
	}
	/** 
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		getHLArc().getBendPoints().remove(bendPoint);
	}

}
