package roneditor.ronview.commands;

import ronmodel.HLPlace;
import ronmodel.HLPlaceType;
import ronmodel.RON;

/**
 * Command for adding a HLPlace to a RON. This is undoable.
 * 
 * @author Tony Modica
 */
public class CreateHLPlaceCommand extends org.eclipse.gef.commands.Command {

	private static final String CreateCommand_Label = "Create HLPlace";

	final private RON ron;

	private HLPlace place;

	private String name;

	private HLPlaceType type;

	private int x;

	private int y;

	public CreateHLPlaceCommand(final RON ron, final HLPlace place) {
		super(CreateHLPlaceCommand.CreateCommand_Label);
		this.ron = ron;
		this.place = place;
	}

	/**
	 * Executes the command by adding the HLPlace to the RON.
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	@Override
	public void execute() {
		place.setRon(ron);
		place.setType(type);
		place.setName(name);
		place.setX(x);
		place.setY(y);
	}

	/**
	 * Undoes the command by removing the HLPlace fromthe RON.
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	@Override
	public void undo() {
		place.setRon(null);
	}

	/**
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	@Override
	public void redo() {
		place.setRon(ron);
	}

	/**
	 * @param name
	 *            the name to set
	 */
	public void setName(final String name) {
		this.name = name;
	}

	/**
	 * @param type
	 *            the type to set
	 */
	public void setType(final HLPlaceType type) {
		this.type = type;
	}

	public void setX(int x) {
		this.x = x;
	}

	public void setY(int y) {
		this.y = y;
	}
}
