package roneditor.ronview.commands;

import ronmodel.Token;

/**
 * command zum selektieren von einem {@link Token}.
 * 
 */
public class SelectTokenCommand extends org.eclipse.gef.commands.Command {
	private Token token;

	private static final String Command_Label_Select_Token = "select token";

	public SelectTokenCommand(Token token) {
		this.token = token;
	}
	/**
	 * Token wird als selektiert markiert
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		token.setSelected(!token.isSelected());
	}

	public String getLabel() {
		return Command_Label_Select_Token;
	}

	/**
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		token.setSelected(!token.isSelected());
	}
	/**
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		token.setSelected(!token.isSelected());
	}
	/**
	 * @see org.eclipse.gef.commands.Command#canExecute()
	 */
	@Override
	public boolean canExecute() {
		return this.token != null;
	}
}
