package roneditor.ronview.commands;

import org.eclipse.draw2d.geometry.Point;

import ronmodel.HLNode;

/**
 * Change the location of a graphical object.
 */
public class SetConstraintCommand extends org.eclipse.gef.commands.Command {
	private static final String Command_Label_Resize = "resize command";

	private Point newPosition;

	private Point oldPosition;

	private HLNode hlNode;

	public void execute() {
		oldPosition = new Point(hlNode.getX(), hlNode.getY());
		hlNode.setX(newPosition.x);
		hlNode.setY(newPosition.y);
	}

	public String getLabel() {
		return Command_Label_Resize;
	}

	public void redo() {
		hlNode.setX(newPosition.x);
		hlNode.setY(newPosition.y);
	}

	public void undo() {
		hlNode.setX(oldPosition.x);
		hlNode.setY(oldPosition.y);
	}

	/**
	 * @return the newPosition
	 */
	public Point getNewPosition() {
		return newPosition;
	}

	/**
	 * @param newPosition
	 *            the newPosition to set
	 */
	public void setNewPosition(Point newPosition) {
		this.newPosition = newPosition;
	}

	/**
	 * @return the node
	 */
	public HLNode getHLNode() {
		return hlNode;
	}

	/**
	 * @param hlNode
	 *            the node to set
	 */
	public void setHLNode(HLNode hlNode) {
		this.hlNode = hlNode;
	}

}
