package roneditor.ronview.edit.policies;

import org.eclipse.draw2d.PolygonDecoration;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.editpolicies.ConnectionEndpointEditPolicy;

import ronmodel.HLArc;

/**
 * Edit policy for the endpoint (e.g. arrow) of a {@link HLArc}.
 */
public class HLArcEndpointEditPolicy extends ConnectionEndpointEditPolicy {

	/**
	 * 
	 */
	public HLArcEndpointEditPolicy() {
		super();
	}

	protected void addSelectionHandles() {
		super.addSelectionHandles();
		getConnectionFigure().setLineWidth(3);
	}

	/**
	 * @return the polyline connection figure with a line end arrow.
	 */
	protected PolylineConnection getConnectionFigure() {
		PolylineConnection con = (PolylineConnection) ((GraphicalEditPart) getHost())
				.getFigure();
		// source decoration -->
		// arrow at the end of the line
		PolygonDecoration decoration = new PolygonDecoration();
		con.setSourceDecoration(decoration);
		return con;
	}
	/**
	 * @see org.eclipse.gef.editpolicies.SelectionHandlesEditPolicy#removeSelectionHandles()
	 */
	protected void removeSelectionHandles() {
		super.removeSelectionHandles();
		getConnectionFigure().setLineWidth(1);
	}
}
