package roneditor.ronview.edit.utils;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;

import roneditor.ronview.edit.parts.HLArcEditPart;
import roneditor.ronview.edit.parts.HLPlaceEditPart;
import roneditor.ronview.edit.parts.HLTransitionEditPart;
import roneditor.ronview.edit.parts.RONEditPart;
import roneditor.ronview.edit.parts.TokenEditPart;
import ronmodel.HLArc;
import ronmodel.HLPlace;
import ronmodel.HLTransition;
import ronmodel.RON;
import ronmodel.Token;

/**
 * Factory class for graphical edit parts. Here, the corresponding edit parts of
 * a ron are created.
 */
public class RONViewEditPartFactory implements EditPartFactory {

	public RONViewEditPartFactory() {
		super();
	}

	/**
	 * @see org.eclipse.gef.EditPartFactory#createEditPart(org.eclipse.gef.EditPart,
	 *      java.lang.Object)
	 */
	public EditPart createEditPart(EditPart context, Object obj) {
		if (obj instanceof RON) {
			RONEditPart p = new RONEditPart((RON) obj);
			return p;
		} else if (obj instanceof HLPlace) {
			HLPlaceEditPart p = new HLPlaceEditPart((HLPlace) obj);
			return p;
		} else if (obj instanceof HLTransition) {
			HLTransitionEditPart p = new HLTransitionEditPart(
					(HLTransition) obj);
			return p;
		} else if (obj instanceof HLArc)
			return new HLArcEditPart((HLArc) obj);
		else if (obj instanceof Token)
			return new TokenEditPart((Token) obj);
		return null;
	}
}
