package roneditor.ronview.figures;

import org.eclipse.draw2d.BendpointConnectionRouter;
import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.Connection;
import org.eclipse.draw2d.MidpointLocator;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.draw2d.RectangleFigure;

import ronmodel.HLArc;

/**
 * Represents the graphical layout of a {@link HLArc}.
 */
public class HLArcFigure extends PolylineConnection {

	public HLArcFigure(Connection con) {

		setSourceAnchor(con.getSourceAnchor());
		setTargetAnchor(con.getTargetAnchor());
		MidpointLocator locator = new MidpointLocator(this, 0);
		RectangleFigure labelFigure = new RectangleFigure();
		labelFigure.setLayoutManager(new BorderLayout());
		labelFigure.setOutline(false);
		add(labelFigure, locator);

		// adds a BendpointConnectionRouter
		// for drawing Bendpoints
		setConnectionRouter(new BendpointConnectionRouter());
	}
}