package roneditor.ruleview.actions;

import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.ui.IWorkbenchPart;

import roneditor.ruleview.RulePage;
import roneditor.ruleview.commands.CreateNACCommand;
import ronmodel.NAC;
import ronmodel.RonmodelFactory;
/**
 * Action for creation of a NAC
 */
public class CreateNACAction extends SelectionAction {

	static public String ID = "create NAC action";

	private RulePage rulePage;

	public CreateNACAction(IWorkbenchPart part, RulePage rulePage) {
		super(part);
		this.rulePage = rulePage;
		setId(ID);
		setText("create NAC");
		setDescription("create NAC");
		setToolTipText("create NAC");

	}
	/**
	 * @see org.eclipse.jface.action.Action#run()
	 */
	@Override
	public void run() {
		CreateNACCommand createCommand = new CreateNACCommand();
		createCommand.setRule(rulePage.getRule());
		NAC newNAC = RonmodelFactory.eINSTANCE.createNAC();
		createCommand.setNac(newNAC);
		execute(createCommand);
	}
	/**
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
	 */
	@Override
	protected boolean calculateEnabled() {
		return true;
	}
}
