package roneditor.ruleview.commands;

import ronmodel.Codomain;
import ronmodel.Mapping;
import ronmodel.ONNode;

/**
 * Command for deleting a mapping.
 */
public class DeleteMappingCommand extends org.eclipse.gef.commands.Command {
	private static final String DeleteCommand_Label = "DeleteMappingCommand";

	private Codomain codomain;

	private Mapping mapping;

	private ONNode source;

	private ONNode target;

	/**
	 * 
	 */
	public DeleteMappingCommand() {
		super(DeleteCommand_Label);
		setLabel("delete Mapping");
	}

	/**
	 * Entry point for command execution.
	 * mapping wird gelscht
	 */
	public void execute() {
		codomain = mapping.getCodomain();
		source = mapping.getSource();
		target = mapping.getTarget();
		target.setMappingID(0);
		mapping.setSource(null);
		mapping.setTarget(null);
		mapping.setCodomain(null);
	}
	/**
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		execute();
	}

	/**
	 * Undo command execution.
	 */
	public void undo() {
		mapping.setSource(source);
		mapping.setTarget(target);
		target.setMappingID(source.getMappingID());
		mapping.setCodomain(codomain);
	}
	/**
	 * @see org.eclipse.gef.commands.Command#canExecute()
	 */
	@Override
	public boolean canExecute() {
		return mapping != null && mapping.getSource() != null
				&& mapping.getTarget() != null && mapping.getCodomain() != null;
	}

	public Mapping getMapping() {
		return mapping;
	}

	public void setMapping(Mapping mapping) {
		this.mapping = mapping;
	}

}
