package roneditor.ruleview.commands;

import java.util.List;

import roneditor.ruleview.RulePage;
import ronmodel.NAC;

/**
 * Command for switch NAC.
 */
public class SwitchNacCommand extends org.eclipse.gef.commands.Command {
	private static final String SwitchNacCommand_Label = "SwitchNACCommand";

	private RulePage rulePage;

	/**
	 * 
	 */
	public SwitchNacCommand(RulePage rulePage) {
		super(SwitchNacCommand_Label);
		setLabel("Switch NAC");
		this.rulePage = rulePage;
	}

	/**
	 * Entry point for command execution.
	 */
	public void execute() {
		final List nacs = rulePage.getRule().getNacs();
		final int actualShowing = nacs.lastIndexOf(rulePage
				.getViewersContents(0));
		final NAC newNACtoShow = (NAC) nacs.get((actualShowing + 1)
				% nacs.size());
		rulePage.setViewersContents(0, newNACtoShow);
	}

	public void redo() {
		execute();
	}

	/**
	 * Undo command execution.
	 */
	public void undo() {
		final List nacs = rulePage.getRule().getNacs();
		final int actualShowing = nacs.lastIndexOf(rulePage
				.getViewersContents(0));
		int newNACindex = actualShowing == 0 ? nacs.size() - 1
				: actualShowing - 1;
		final NAC newNACtoShow = (NAC) nacs.get(newNACindex);
		rulePage.setViewersContents(0, newNACtoShow);
	}

	@Override
	public boolean canExecute() {
		return rulePage.getRule().getNacs().size() > 1;
	}

}
