package roneditor.ruleview.edit.parts;

import org.eclipse.emf.common.notify.Notification;

import roneditor.AbstractMultiViewerPage.MultiViewerPageViewer;
import roneditor.objectnetview.edit.parts.ObjectNetEditPart;
import ronmodel.Codomain;
import ronmodel.LHS;
import ronmodel.Mapping;
import ronmodel.ONNode;
/**
 * editpart for a LHS
 */
public class LHSEditPart extends ObjectNetEditPart {
	public LHSEditPart(LHS lhs) {
		super(lhs);
	}

	/**
	 * bei nderungen im Modell werden alle markern 
	 * aktualisiert
	 */
	public void refreshMarkers() {
		if (getViewer() instanceof MultiViewerPageViewer) {
			LHS lhs = (LHS) getModel();
			ONNode node = null;
			Mapping mapping = null;

			for (Object o : lhs.getNodes()) {
				node = (ONNode) o;
				for (Object o1 : node.getOutgoingMappings()) {
					mapping = (Mapping) o1;
					if (mapping.getCodomain() instanceof Codomain) {
						mapping.getCodomain().eNotify(null);
					}
				}
			}
		}		
	}
	/**
	 * @see roneditor.objectnetview.edit.parts.ObjectNetEditPart#notifyChanged(org.eclipse.emf.common.notify.Notification)
	 */
	@Override
	public void notifyChanged(Notification notification) {
		int type = notification.getEventType();
		switch (type) {
		case Notification.ADD:
		case Notification.ADD_MANY:
		case Notification.REMOVE:
		case Notification.REMOVE_MANY:
			refreshChildren();
			refreshMarkers();
			break;
		case Notification.SET:
			nameLabel.setText(getObjectNet().getName());
			refreshVisuals();
			break;
		}
	}
}
