package roneditor.ruleview.edit.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreateConnectionRequest;

import roneditor.ruleview.commands.CreateMappingCommand;
import ronmodel.Codomain;
import ronmodel.LHS;
import ronmodel.Mapping;

/**
 * EditPolicy for a ONNode.
 */
public class ONNodeEditPolicy extends
		roneditor.objectnetview.edit.policies.ONNodeEditPolicy {

	public ONNodeEditPolicy() {
		super();
	}

	/**
	 * @see org.eclipse.gef.editpolicies.GraphicalNodeEditPolicy#getConnectionCompleteCommand(org.eclipse.gef.requests.CreateConnectionRequest)
	 */
	protected Command getConnectionCompleteCommand(
			CreateConnectionRequest request) {
		Command command = request.getStartCommand();
		if (command instanceof CreateMappingCommand) {
			CreateMappingCommand createMappingCommand = (CreateMappingCommand) command;
			createMappingCommand.setTarget(getONNode());
			if (getONNode().getObjectNet() instanceof Codomain) {
				createMappingCommand.setCodomain((Codomain) getONNode()
						.getObjectNet());
				return command;
			} else {
				return null;
			}
		}
		return super.getConnectionCompleteCommand(request);
	}

	/**
	 * @see org.eclipse.gef.editpolicies.GraphicalNodeEditPolicy#getConnectionCreateCommand(org.eclipse.gef.requests.CreateConnectionRequest)
	 */
	protected Command getConnectionCreateCommand(CreateConnectionRequest request) {
		Object reqObj = request.getNewObject();
		if (reqObj instanceof Mapping) {
			if (getONNode().getObjectNet() instanceof LHS) {
				CreateMappingCommand command = new CreateMappingCommand();
				command.setMapping((Mapping) reqObj);
				command.setSource(getONNode());
				request.setStartCommand(command);
				return command;
			} else {
				return null;
			}
		}
		return super.getConnectionCreateCommand(request);
	}
}
