package roneditor.ruleview.edit.utils;

import org.eclipse.gef.EditPart;

import roneditor.objectnetview.edit.parts.ONArcEditPart;
import roneditor.objectnetview.edit.utils.ObjectNetViewEditPartFactory;
import roneditor.ruleview.edit.parts.LHSEditPart;
import roneditor.ruleview.edit.parts.MappingEditPart;
import roneditor.ruleview.edit.parts.NACEditPart;
import roneditor.ruleview.edit.parts.ONPlaceEditPart;
import roneditor.ruleview.edit.parts.ONTransitionEditPart;
import roneditor.ruleview.edit.parts.RHSEditPart;
import ronmodel.LHS;
import ronmodel.Mapping;
import ronmodel.NAC;
import ronmodel.ONArc;
import ronmodel.ONPlace;
import ronmodel.ONTransition;
import ronmodel.RHS;
import ronmodel.Rule;
/**
 * Factory class for graphical edit parts. Here, the corresponding edit parts of
 * a {@link Rule} are created.
 */
public class RuleViewEditPartFactory extends ObjectNetViewEditPartFactory {

	/**
	 * @see roneditor.objectnetview.edit.utils.ObjectNetViewEditPartFactory#createEditPart(org.eclipse.gef.EditPart,
	 *      java.lang.Object)
	 */
	public EditPart createEditPart(EditPart context, Object obj) {
		if (obj instanceof LHS) {
			LHSEditPart p = new LHSEditPart((LHS) obj);
			return p;
		} else if (obj instanceof RHS) {
			RHSEditPart p = new RHSEditPart((RHS) obj);
			return p;
		} else if (obj instanceof NAC) {
			NACEditPart p = new NACEditPart((NAC) obj);
			return p;
		} else if (obj instanceof Mapping) {
			MappingEditPart p = new MappingEditPart((Mapping) obj);
			return p;
		} else if (obj instanceof ONPlace) {
			ONPlaceEditPart p = new ONPlaceEditPart((ONPlace) obj);
			return p;
		} else if (obj instanceof ONTransition) {
			ONTransitionEditPart p = new ONTransitionEditPart(
					(ONTransition) obj);
			return p;
		} else if (obj instanceof ONArc) {
			ONArcEditPart p = new ONArcEditPart((ONArc) obj);
			return p;
		}
		return null;
	}
}
