package roneditor.ruleview.model;

import java.util.Map;

import org.eclipse.emf.ecore.EPackage;
import org.eclipse.gef.requests.CreationFactory;

import ronmodel.Mapping;
import ronmodel.RonmodelFactory;
import ronmodel.RonmodelPackage;

/**
 * This class implements the CreationFactory used by the CreationTool. It in
 * turn uses the EMF-generated factories to create the model instances
 * 
 */
public class RuleModelCreationFactory implements CreationFactory {
	private Class targetClass;

	public RuleModelCreationFactory(Class targetClass) {
		this.targetClass = targetClass;
	}

	/**
	 * @see org.eclipse.gef.requests.CreationFactory#getNewObject()
	 */
	public Object getNewObject() {
		Map registry = EPackage.Registry.INSTANCE;
		String ronmodelURI = RonmodelPackage.eNS_URI;
		RonmodelPackage ronmodelPackage = (RonmodelPackage) registry
				.get(ronmodelURI);
		RonmodelFactory factory = ronmodelPackage.getRonmodelFactory();

		Object result = null;
		if (targetClass.equals(Mapping.class)) {
			result = factory.createMapping();
		}
		return result;
	}

	/**
	 * @see org.eclipse.gef.requests.CreationFactory#getObjectType()
	 */
	public Object getObjectType() {
		return targetClass;
	}
}
