/**
 * <copyright>
 * </copyright>
 *
 * $Id: RonmodelSwitch.java,v 1.2 2007/05/23 11:50:11 wlicht Exp $
 */
package ronmodel.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import ronmodel.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see ronmodel.RonmodelPackage
 * @generated
 */
public class RonmodelSwitch {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static RonmodelPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RonmodelSwitch() {
		if (modelPackage == null) {
			modelPackage = RonmodelPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public Object doSwitch(final EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch((EClass)eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected Object doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case RonmodelPackage.RON: {
				RON ron = (RON)theEObject;
				Object result = caseRON(ron);
				if (result == null) result = caseNamedElement(ron);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.TOKEN: {
				Token token = (Token)theEObject;
				Object result = caseToken(token);
				if (result == null) result = caseNamedElement(token);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.OBJECT_NET: {
				ObjectNet objectNet = (ObjectNet)theEObject;
				Object result = caseObjectNet(objectNet);
				if (result == null) result = caseToken(objectNet);
				if (result == null) result = caseNamedElement(objectNet);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.RULE: {
				Rule rule = (Rule)theEObject;
				Object result = caseRule(rule);
				if (result == null) result = caseToken(rule);
				if (result == null) result = caseNamedElement(rule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.CODOMAIN: {
				Codomain codomain = (Codomain)theEObject;
				Object result = caseCodomain(codomain);
				if (result == null) result = caseObjectNet(codomain);
				if (result == null) result = caseToken(codomain);
				if (result == null) result = caseNamedElement(codomain);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.MAPPING: {
				Mapping mapping = (Mapping)theEObject;
				Object result = caseMapping(mapping);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.LHS: {
				LHS lhs = (LHS)theEObject;
				Object result = caseLHS(lhs);
				if (result == null) result = caseObjectNet(lhs);
				if (result == null) result = caseToken(lhs);
				if (result == null) result = caseNamedElement(lhs);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.RHS: {
				RHS rhs = (RHS)theEObject;
				Object result = caseRHS(rhs);
				if (result == null) result = caseCodomain(rhs);
				if (result == null) result = caseObjectNet(rhs);
				if (result == null) result = caseToken(rhs);
				if (result == null) result = caseNamedElement(rhs);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.NAC: {
				NAC nac = (NAC)theEObject;
				Object result = caseNAC(nac);
				if (result == null) result = caseCodomain(nac);
				if (result == null) result = caseObjectNet(nac);
				if (result == null) result = caseToken(nac);
				if (result == null) result = caseNamedElement(nac);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.HL_NODE: {
				HLNode hlNode = (HLNode)theEObject;
				Object result = caseHLNode(hlNode);
				if (result == null) result = caseNamedElement(hlNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.HL_ARC: {
				HLArc hlArc = (HLArc)theEObject;
				Object result = caseHLArc(hlArc);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.HL_PLACE: {
				HLPlace hlPlace = (HLPlace)theEObject;
				Object result = caseHLPlace(hlPlace);
				if (result == null) result = caseHLNode(hlPlace);
				if (result == null) result = caseNamedElement(hlPlace);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.HL_TRANSITION: {
				HLTransition hlTransition = (HLTransition)theEObject;
				Object result = caseHLTransition(hlTransition);
				if (result == null) result = caseHLNode(hlTransition);
				if (result == null) result = caseNamedElement(hlTransition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.ON_NODE: {
				ONNode onNode = (ONNode)theEObject;
				Object result = caseONNode(onNode);
				if (result == null) result = caseNamedElement(onNode);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.ON_ARC: {
				ONArc onArc = (ONArc)theEObject;
				Object result = caseONArc(onArc);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.ON_PLACE: {
				ONPlace onPlace = (ONPlace)theEObject;
				Object result = caseONPlace(onPlace);
				if (result == null) result = caseONNode(onPlace);
				if (result == null) result = caseNamedElement(onPlace);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.ON_TRANSITION: {
				ONTransition onTransition = (ONTransition)theEObject;
				Object result = caseONTransition(onTransition);
				if (result == null) result = caseONNode(onTransition);
				if (result == null) result = caseNamedElement(onTransition);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.NAMED_ELEMENT: {
				NamedElement namedElement = (NamedElement)theEObject;
				Object result = caseNamedElement(namedElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case RonmodelPackage.BEND_POINT: {
				BendPoint bendPoint = (BendPoint)theEObject;
				Object result = caseBendPoint(bendPoint);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>RON</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>RON</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRON(final RON object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Token</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Token</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseToken(final Token object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Object Net</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Object Net</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseObjectNet(final ObjectNet object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRule(final Rule object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Codomain</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Codomain</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCodomain(final Codomain object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Mapping</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Mapping</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseMapping(final Mapping object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>LHS</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>LHS</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseLHS(final LHS object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>RHS</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>RHS</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseRHS(final RHS object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>NAC</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>NAC</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseNAC(final NAC object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>HL Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>HL Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseHLNode(final HLNode object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>HL Arc</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>HL Arc</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseHLArc(final HLArc object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>HL Place</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>HL Place</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseHLPlace(final HLPlace object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>HL Transition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>HL Transition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseHLTransition(final HLTransition object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>ON Node</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>ON Node</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseONNode(final ONNode object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>ON Arc</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>ON Arc</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseONArc(final ONArc object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>ON Place</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>ON Place</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseONPlace(final ONPlace object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>ON Transition</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>ON Transition</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseONTransition(final ONTransition object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Named Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Named Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseNamedElement(final NamedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>Bend Point</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>Bend Point</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBendPoint(BendPoint object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpretting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public Object defaultCase(final EObject object) {
		return null;
	}

} //RonmodelSwitch
